/**
******************************************************************************
* @file         tcp_client.c
* @version      V1.0
* @date         2020-06-05
* @brief        tcp clinetݻػ
*        
* @company      Ƽ޹˾
* @information  WIZnet W5500ٷ̣ȫ̼֧֣۸ƴ
* @website      www.wisioe.com
* @forum        www.w5500.cn
* @Support      QQ:2571856470Mob:18998931307
* @Email        support@wisioe.com
******************************************************************************
*/
#include <stdio.h>
#include "tcp_client.h"
#include "socket.h"
#include "w5500.h"
#include "w5500_conf.h"

uint8_t tcp_client_buff[DATA_BUF_SIZE];	

void do_tcp_client(void)
{
  uint16 len=0;	

  switch(getSn_SR(SOCK_TCPC))                           // ȡsocket״̬
  {
    case SOCK_CLOSED:                                   // socketڹر״̬
      socket(SOCK_TCPC,Sn_MR_TCP,local_port++,Sn_MR_ND);
      break;

    case SOCK_INIT:                                     // socketڳʼ״̬
      connect(SOCK_TCPC,remote_ip,remote_port);         // socketӷ 
      break;

    case SOCK_ESTABLISHED:                              // socketӽ״̬
      if(getSn_IR(SOCK_TCPC) & Sn_IR_CON)
      {
        setSn_IR(SOCK_TCPC, Sn_IR_CON);                 // жϱ־λ
      }

      len=getSn_RX_RSR(SOCK_TCPC);                      // lenΪѽݵĳ
      if(len>0)
      {
        recv(SOCK_TCPC,tcp_client_buff,len);                       // Server
        tcp_client_buff[len]=0x00;                                 // ַ
        printf("%s\r\n",tcp_client_buff);
        send(SOCK_TCPC,tcp_client_buff,len);                       // Server
      }		  
      break;

    case SOCK_CLOSE_WAIT:                               // socketڵȴر״̬
      disconnect(SOCK_TCPC);                            // ϿǰTCP
      close(SOCK_TCPC);                                 // رյǰʹsocket
      break;
  }
}
